

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
	SWEP.HoldType			= "smg"
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "Demoman's Grenadelauncher"			
	SWEP.Author				= "The Mathias"
	SWEP.Slot				= 3
	SWEP.SlotPos			= 1
	SWEP.IconLetter			= "z"
	
	killicon.AddFont( "weapon_grenadelauncher", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
end


//SWEP.Base				= "weapon_cs_base"
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_models/v_grenadelauncher_demo.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_grenadelauncher.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.Primary.Sound			= Sound( "Weapon_GrenadeLauncher.Single" )
SWEP.Primary.ClipSize		= 4
SWEP.Primary.Delay			= 0.75
SWEP.Primary.DefaultClip	= 36
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "Buckshot"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"

function SWEP:Initialize()
	if SERVER then self:SetWeaponHoldType( "smg" ) end
end

function SWEP:PrimaryAttack()
	
	self.Weapon:SetNextSecondaryFire( CurTime() + self.Primary.Delay )
	self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
	
	if self.Weapon:Clip1() <= 0 then
		self:Reload()
		return
	end
	
	if ( !self:CanPrimaryAttack() ) then return end
	
	if self.Reloading then
		timer.Destroy( "Reload_" .. self.Weapon:EntIndex() )
		self.Reloading = false
	end
	
	self.Weapon:EmitSound( self.Primary.Sound )
	
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK ) 
	self:TakePrimaryAmmo( 1 )
	
	if CLIENT then return end

	local Grenade = ents.Create("grenadelauncher_grenade")
	local Pos = self.Owner:GetShootPos() + ( self.Owner:GetAimVector() * 20 )
	Grenade:Spawn()
	Grenade:SetModel( "models/weapons/w_models/w_grenade_grenadelauncher.mdl" )
	Grenade:Activate()
	Grenade:SetPos( Pos )
	Grenade:SetAngles( self.Owner:GetAimVector():Angle() )
	Grenade:GetPhysicsObject():ApplyForceCenter( self.Owner:GetAimVector() * 5000 )
	Grenade.Owner = self.Owner
	
	util.SpriteTrail( Grenade, 0, Color( 255, 0, 0, 255 ), false, 20, 5, 0.7, 1 / (( 20 + 5 ) * 0.5), "trails/laser.vmt" )
	
end

function SWEP:Reload()
	if SERVER then
		if !(self.Owner:GetActiveWeapon():GetClass() == "weapon_grenadelauncher") then return end
		if self.Reloading || self.Owner:GetAmmoCount( "Buckshot" ) == 0 then return end
		if self.Weapon:Clip1() < 4 then
			self.Weapon:SendWeaponAnim( ACT_RELOAD_START )
			self.Reloading = true
			timer.Create( "Reload_" .. self.Weapon:EntIndex(), 0.75, 5- self.Weapon:Clip1(), self.PerformReload, self )
		end
	end
end

function SWEP:Holster()
	if self.Reloading then
		self.Reloading = false
		timer.Destroy( "Reload_" .. self.Weapon:EntIndex() )
	end
	return true
end

function SWEP:PerformReload()
	if !self.Reloading then 
		timer.Destroy( "Reload_" .. self.Weapon:EntIndex() )
		return
	end
	local Ammo = self.Weapon:Clip1( )
	
	if Ammo >= 4 || self.Owner:GetAmmoCount( "Buckshot" ) == 0 then
		self.Reloading = false
		timer.Destroy( "Reload_" .. self.Weapon:EntIndex() )
		self.Weapon:SendWeaponAnim( ACT_RELOAD_FINISH )
	else
		self.Reloading = true
		self.Weapon:SendWeaponAnim( ACT_VM_RELOAD )
		if self.Owner:GetAmmoCount( "Buckshot" ) <= 0 then return end
		self.Owner:RemoveAmmo( 1, self.Primary.Ammo, false )
		self.Weapon:SetClip1(  self.Weapon:Clip1() + 1 )
		self.Weapon:SetNextSecondaryFire( CurTime() + 0.5 )
		self.Weapon:SetNextPrimaryFire( CurTime() + 0.5 )
	end
end
		
function SWEP:Deploy()
	self.Weapon:EmitSound( Sound( "Weapon_GrenadeLauncher.Draw" ) )
end

function SWEP:SecondaryAttack()
end
