

if ( SERVER ) then

	AddCSLuaFile( "shared.lua" )
	
end

if ( CLIENT ) then

	SWEP.PrintName			= "Heavy's Minigun"			
	SWEP.Author				= "The Mathias"
	SWEP.Slot				= 3
	SWEP.SlotPos			= 1
	SWEP.IconLetter			= "z"
	
	killicon.AddFont( "weapon_minigun", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
	
end


//SWEP.Base				= "weapon_cs_base"
SWEP.Category			= "Team Fortress 2"

SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true

SWEP.ViewModel			= "models/weapons/v_models/v_minigun_heavy.mdl"
SWEP.WorldModel			= "models/weapons/w_models/w_minigun.mdl"

SWEP.Weight				= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false

SWEP.Primary.Sound			= Sound( "Weapon_MiniGun.Fire" )
SWEP.Primary.ClipSize		= 200
SWEP.Primary.Delay			= 0.1
SWEP.Primary.DefaultClip	= 200
SWEP.Primary.Automatic		= true
SWEP.Primary.Ammo			= "ar2"
SWEP.IdleTimer 				= false

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"
SWEP.SetSpeedAlready		= false

function SWEP:Initialize()
	if SERVER then self:SetWeaponHoldType( "smg" ) end
	self.NextSecondaryFire = CurTime() + self.Primary.Delay
	self.NextPrimaryFire = CurTime() + self.Primary.Delay
	self.LastClipPlay = CurTime()
end

function SWEP:SetIdleAnim()
	if !self.StartSpin && !self.Holstered then
		self.Weapon:SendWeaponAnim( ACT_VM_IDLE )
	end	
end

function SWEP:SetDefaultSpeed()
	if !self.SetSpeedAlready then
		GAMEMODE:SetPlayerSpeed( self.Owner, 250, 500 )
		self.SetSpeedAlready = true
	end
end

function SWEP:Think()
	if SERVER then
		if self.StartSpin then
			GAMEMODE:SetPlayerSpeed( self.Owner, 80, 80 )
			self.Owner:SprintDisable()
			self.SetSpeedAlready = false
		end
	end
	
	if self.StartSpin && self.Weapon:Clip1() == 0 then
		self.Weapon:SendWeaponAnim( ACT_MP_ATTACK_STAND_POSTFIRE )
		self.Weapon:EmitSound( Sound( "Weapon_MiniGun.WindDown" ) )
		self.StartSpin = false
		self:SetDefaultSpeed()
		if SERVER then
			self.Owner:SprintEnable()
		end
		self.Weapon:StopSound( Sound( "Weapon_MiniGun.Spin" ) )
		self:SetIdleAnim()
		return
	end
	
	if self.StartSpin && !self.Owner:KeyDown(1) && !self.Owner:KeyDown(2048) && CurTime() - self.StartSpin > 1 then
		self.Weapon:SendWeaponAnim( ACT_MP_ATTACK_STAND_POSTFIRE )
		self.Weapon:EmitSound( Sound( "Weapon_MiniGun.WindDown" ) )
		self.StartSpin = false
		timer.Simple( 1, self.SetDefaultSpeed, self )
		if SERVER then
			timer.Simple( 1, self.Owner.SprintEnable, self.Owner )
		end
		self.Weapon:StopSound( Sound( "Weapon_MiniGun.Spin" ) )
		timer.Simple( 1, self.SetIdleAnim, self )
		return
	end
	
	
	if self.StartSpin && CurTime() - self.StartSpin > 1 && self.Owner:KeyDown(2048) then
		self.Weapon:EmitSound( Sound( "Weapon_MiniGun.Spin" ) )
	end
	
	if self.StartSpin && CurTime() - self.StartSpin > 1 && !self.Owner:KeyDown(1) && self.Owner:KeyDown(2048) then
		self.Weapon:SendWeaponAnim( ACT_VM_SECONDARYATTACK )
		self.Weapon:StopSound( "Weapon_MiniGun.Fire" )
	elseif self.StartSpin && CurTime() - self.StartSpin > 1 && self.Owner:KeyDown(1) && self:CanPrimaryAttack() then
		self.Weapon:CSShootBullet( 20, 0, 4, 0.25 )
		self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )
	end
	
end	

function SWEP:CanPrimaryAttack()
	if self.Weapon:Clip1() > 0 && self.NextPrimaryFire < CurTime() then
		return true
	end
	return false
end

function SWEP:PrimaryAttack()

	if ( !self:CanPrimaryAttack() ) then return end

	self.NextSecondaryFire = CurTime() + self.Primary.Delay
	self.NextPrimaryFire = CurTime() + self.Primary.Delay
	
	if !self.StartSpin then
		self.Weapon:EmitSound( Sound( "Weapon_MiniGun.WindUp" ) )
		self.Weapon:SendWeaponAnim( ACT_MP_ATTACK_STAND_PREFIRE )
		self.StartSpin = CurTime()
	end	
end

function SWEP:SecondaryAttack()
	if ( !self:CanPrimaryAttack() ) then return end

	self.NextSecondaryFire = CurTime() + self.Primary.Delay
	self.NextPrimaryFire = CurTime() + self.Primary.Delay
	
	if !self.StartSpin then
		self.Weapon:EmitSound( Sound( "Weapon_MiniGun.WindUp" ) )
		self.Weapon:SendWeaponAnim( ACT_MP_ATTACK_STAND_PREFIRE )
		self.StartSpin = CurTime()
	end	
end

function SWEP:CSShootBullet( dmg, recoil, numbul, cone )

	numbul 	= numbul 	or 1
	cone 	= cone 		or 0.01

	local bullet = {}
	bullet.Num 		= numbul
	bullet.Src 		= self.Owner:GetShootPos()			// Source
	bullet.Dir 		= self.Owner:GetAimVector()			// Dir of bullet
	bullet.Spread 	= Vector( cone, cone, 0 )			// Aim Cone
	bullet.Tracer	= 1									// Show a tracer on every x bullets 
	bullet.Force	= 10									// Amount of force to give to phys objects
	bullet.Damage	= dmg
	
	self.Owner:FireBullets( bullet )
	self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK ) 		// View model animation
	self.Owner:MuzzleFlash()								// Crappy muzzle light
	self.Owner:SetAnimation( PLAYER_ATTACK1 )				// 3rd Person Animation
	self.Weapon:EmitSound( self.Primary.Sound )
	self:TakePrimaryAmmo( 1 )

end

function SWEP:Reload()
end

function SWEP:Holster()
	self.Weapon:StopSound( "Weapon_MiniGun.WindUp" )
	self.Weapon:StopSound( "Weapon_MiniGun.WindDown" )
	self.Weapon:StopSound( "Weapon_MiniGun.Spin" )
	self.Weapon:StopSound( "Weapon_MiniGun.Fire" )
	self.Holstered = true
	GAMEMODE:SetPlayerSpeed( self.Owner, 250, 500 )
	if SERVER then
		self.Owner:SprintEnable()
	end
	return true
end

function SWEP:Deploy()
	if self.Holstered then
		self.Weapon:EmitSound( Sound( "Weapon_MiniGun.Draw" ) )
		self.Holstered = false
	end
end
